package com.example.lambda;

import java.util.List;
import java.util.function.Function;

/**
 * @author MikeW
 */
public class NameTestNew {

  public static void main(String[] args) {
    
    System.out.println("\n==== NameTestNew02 ===");
    
    List<Person> list1 = Person.createShortList();
    PersonWriterNew pw = new PersonWriterNew();

    // Define Lambda Functions
    Function<Person, String> shortWestern = p -> {
        return "\nName: " + p.getGivenName() + " " + p.getSurName() + "\n" +
        "EMail: " + p.getEmail() + "\n" +
        "Phone: " + p.getPhone(); 
    };
    
  
    Function<Person, String> shortGangnam =  p -> "\nName: " + 
            p.getSurName() + " " + p.getGivenName() + "\n" +
            "EMail: " + p.getEmail() + "\n" +
            "Phone: " + p.getPhone();
    
    
    Function<Person, String> fullWestern = p -> {
      return "\nName: " + p.getGivenName() + " " + p.getSurName() + "\n" +
             "Age: " + p.getAge() + "  " + "Gender: " + p.getGender() + "\n" +
             "EMail: " + p.getEmail() + "\n" + 
             "Phone: " + p.getPhone() + "\n" +
             "Address: " + p.getAddress();
    };
    
    Function<Person, String> fullGangnam =  p -> "\nName: " + p.getSurName() + " " 
            + p.getGivenName() + "\n" + "Age: " + p.getAge() + "  " + 
            "Gender: " + p.getGender() + "\n" +
            "EMail: " + p.getEmail() + "\n" + 
            "Phone: " + p.getPhone() + "\n" +
            "Address: " + p.getAddress();   
    
    // print list
    pw.printLambdaList(list1, fullWestern, "\n==== Full Western Style ====");
    pw.printLambdaList(list1, shortGangnam, "\n==== Short Gangnam Style ====");
    
  }
}
